<?php
/*
 * FCKeditor - The text editor for Internet - http://www.fckeditor.net
 * Copyright (C) 2003-2008 Frederico Caldeira Knabben
 *
 * == BEGIN LICENSE ==
 *
 * Licensed under the terms of any of the following licenses at your
 * choice:
 *
 *  - GNU General Public License Version 2 or later (the "GPL")
 *    http://www.gnu.org/licenses/gpl.html
 *
 *  - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
 *    http://www.gnu.org/licenses/lgpl.html
 *
 *  - Mozilla Public License Version 1.1 or later (the "MPL")
 *    http://www.mozilla.org/MPL/MPL-1.1.html
 *
 * == END LICENSE ==
 *
 * File Name: connector.php
 * 	This is the ImageAdjustor Connector for PHP.
 *
 * File Authors:
 *  Akira Taniguchi (akira@behappy.2-d.jp)
 */

mb_internal_encoding( 'UTF-8' ) ;
mb_regex_encoding( 'UTF-8' ) ;

ob_start() ;

include('config.php') ;
include('basexml.php') ;


//======================================================================
// Define for file access

// DIRECTORY_SEPARATOR

if (! defined('DIRECTORY_SEPARATOR')) {
	define('DIRECTORY_SEPARATOR', (isset($_ENV['OS']) ? (ereg('^Windows', $_ENV['OS']) ? '\\' : '/') : '/'));
}

// root path

if (! defined('ROOT_PATH')) {
	$realpath = mb_convert_encoding( realpath( './' ), 'UTF-8', FileEncoding ) ;
	
	$selfpath_part = mb_split( '/', dirname($_SERVER['PHP_SELF']) ) ;
	
	for ($n = 0; $n < count($selfpath_part); $n++)
	    $selfpath_part[$n] = mb_convert_encoding(rawurldecode($selfpath_part[$n]), 'UTF-8', FileEncoding);
	
	$selfpath = implode( DIRECTORY_SEPARATOR, $selfpath_part ) ;
	
	define('ROOT_PATH', mb_substr($realpath, 0, mb_strlen($realpath) - mb_strlen($selfpath))) ;
}

// Convert Web path to File path

function path($path) {
	return ROOT_PATH . mb_convert_encoding($path, FileEncoding, 'UTF-8');
}

//======================================================================


if ( ! isset( $_GET['Source'] )) SendError( 100, "" ) ;
if ( ! isset( $_GET['Rotate'] )) SendError( 100, "" ) ;
if ( ! isset( $_GET['Scale'] )) SendError( 100, "" ) ;
if ( ! isset( $_GET['X'] )) SendError( 100, "" ) ;
if ( ! isset( $_GET['Y'] )) SendError( 100, "" ) ;
if ( ! isset( $_GET['Width'] )) SendError( 100, "" ) ;
if ( ! isset( $_GET['Height'] )) SendError( 100, "" ) ;

// Check the source.
if ( ! mb_ereg( '^(https?://([^/]+)(:[^/]+)?(/([^/]+/)*))([^/]+)$', $_GET['Source'], $part ) )
	SendError( 101, "" ) ;

$urlbase = $part[1];
$urlhost = $part[2];
$urldir = mb_convert_encoding(rawurldecode($part[4]), 'UTF-8', FileEncoding);
$urlfile = mb_convert_encoding(rawurldecode($part[6]), 'UTF-8', FileEncoding);
$urlpath = "{$urldir}{$urlfile}";

// Check the hostname.
if ( $urlhost != $_SERVER['HTTP_HOST'] )
	SendError( 102, "" ) ;

// Check the source.
if ( ! is_file( path($urlpath) ) )
	SendError( 103, $urlpath ) ;

if ( ! mb_ereg( '^(.+)(\..+)$', $urlfile, $part ) )
	SendError( 104, $urlfile ) ;

$sourceName = $part[1];
$sourceExt = $part[2];

// Create new filename.

if ( ereg( "^(.+)_ia([0-9]+)$", $sourceName, $part ) )
{
	$sourceName = $part[1];
	$n = $part[2] + 1;
}
else
	$n = 1;

$newfile = sprintf("{$sourceName}_ia%02d{$sourceExt}", $n);

while (file_exists(path("{$urldir}{$newfile}")))
{
	$n++;
	$newfile = sprintf("{$sourceName}_ia%02d{$sourceExt}", $n);
}

$newpath = "{$urldir}{$newfile}";
$newUrl = $urlbase . rawurlencode(mb_convert_encoding($newfile, FileEncoding, 'UTF-8'));

// Execute

CreateXmlHeader( $_GET['Source'] ) ;

DoAdjust( $urlpath, $newfile, $newpath, $newUrl );

CreateXmlFooter() ;

exit ;


function DoAdjust( $urlpath, $newfile, $newpath, $newUrl )
{
	
	// image information
	
	if ( ( $info = getimagesize( path($urlpath) ) ) === false ) {
		echo '<Error number="110" text="" />';
		return;
	}
	
	$imageWidth = $info[0];
	$imageHeight = $info[1];
	$imageType = $info[2];
	
	switch ($imageType) {
		case  1:		// gif
		case  2:		// jpg
		case  3:		// png
			break;
		default:
			echo '<Error number="111" text="" />';
			return;
	}
	
	// File -> source
	
	switch ($imageType) {
		case  1:
			$source = @imagecreatefromgif(path($urlpath));
			break;
		case  2:
			$source = @imagecreatefromjpeg(path($urlpath)); 
			break;
		case  3:
			$source = @imagecreatefrompng(path($urlpath)); 
			break;
	}
	
	if ( $source === false ) {
		echo '<Error number="112" text="" />';
		return;
	}
	
	$trans = imagecolortransparent($source);
	
	// source -> scale
	
	$width = floor($imageWidth * $_GET['Scale']);
	$height = floor($imageHeight * $_GET['Scale']);
	
	if ( ( $scale = @imagecreatetruecolor($width, $height) ) === false ) {
		echo '<Error number="113" text="" />';
		return;
	}
	
	if ($trans) {
		imagepalettecopy($scale, $source);
		imagefill($scale, 0, 0, $trans);
		imagecolortransparent($scale, $trans);
	}
	
	imagecopyresized($scale, $source, 0, 0, 0, 0, $width, $height, $imageWidth, $imageHeight);
	
	//imagedestroy($source);
	
	switch ( true ) {
		case ( ($_GET['Rotate'] * 1) % 180 == 0 ) :
			$rotate_width = $width ;
			$rotate_height = $height ;
			break ;
		
		case ( ($_GET['Rotate'] * 1) % 90 == 0 ) :
			$rotate_width = $height ;
			$rotate_height = $width ;
			break ;
		
		default :
			$cos = cos( deg2rad($_GET['Rotate'] * 1) ) ;
			$sin = sin( deg2rad($_GET['Rotate'] * 1) ) ;
			
    		$rotate_width = abs( $cos * $width - $sin * $height ) ;
    		$rotate_height = abs( $cos * $height + $sin * $width ) ;
	}
	
	if ( ( $rotate = @imagerotate( $scale, ( 360 - $_GET['Rotate'] * 1 ), 0 ) ) === false ) {
		echo '<Error number="114" text="" />';
		return;
	}
	
	imagedestroy( $scale ) ;
	
	$size = max( $rotate_width, $rotate_height ) ;			// square size for rotate
	
	if ( ( $square = @imagecreatetruecolor( $size, $size ) ) === false ) {
		echo '<Error number="115" text="" />';
		return;
	}
	
	if ($trans) {
		imagepalettecopy($square, $rotate);
		imagefill($square, 0, 0, $trans);
		imagecolortransparent($square, $trans);
	} else {
		$white = imagecolorallocate($square, 255, 255, 255);
		imagefill($square, 0, 0, $white);
	}
	
	imagecopy( $square, $rotate, ( $size - $rotate_width ) / 2, ( $size - $rotate_height ) / 2, 0 , 0, $rotate_width, $rotate_height ) ;
	
	imagedestroy( $rotate ) ;
	
	// square -> adjust
	
	if ( ( $adjust = @imagecreatetruecolor( $_GET['Width'], $_GET['Height'] ) ) === false ) {
		echo '<Error number="116" text="" />';
		return;
	}
	
	if ( $trans ) {
		imagepalettecopy( $adjust, $square ) ;
		imagecolortransparent( $adjust, $trans ) ;
		imagefill( $adjust, 0, 0, $trans ) ;
	}
	
	// 中心からの始点
	
	$x = $_GET['X'] - $size / 2 ;
	$y = $_GET['Y'] - $size / 2 ;
	
	// 始点
	
	$sx = 0 ;
	$sw = $size ;
	
	$sy = 0 ;
	$sh = $size ;
	
	$dx = $_GET['Width'] / 2 + $x ;
	$dy = $_GET['Height'] / 2 + $y ;
	
	if ( $dx < 0 ) {
		$sx -= $dx ;
		$sw += $dx ;
		$dx = 0 ;
	}
	
	$z = $dx + $sw - 1 ;
	
	if ( $z > $_GET['Width'] ) {
		$sw -= ( $z - $_GET['Width'] ) ;
	}
	
	if ( $dy < 0 ) {
		$sy -= $dy ;
		$sh += $dy ;
		$dy = 0 ;
	}
	
	$z = $dy + $sh - 1 ;
	
	if ( $z > $_GET['Height'] ) {
		$sh -= ( $z - $_GET['Height'] ) ;
	}
	
	imagecopy( $adjust, $square, $dx, $dy, $sx, $sy, $sw, $sh ) ;
	
	imagedestroy( $square ) ;
	
	// adjust -> File
	
	switch ($imageType)
	{
		case  1:
			$res = @imagegif($adjust, path($newpath));
			break;
		case  2:
			$res = @imagejpeg($adjust, path($newpath));
			break;
		case  3:
			$res = @imagepng($adjust, path($newpath)); 
			break;
	}
	
	imagedestroy($adjust);
	
	if ( $res === false )
	{
		echo '<Error number="117" text="' . $newpath . '" />';
		return;
	}
	
	if ( ! is_file( path($newpath) ) )
	{
		echo '<Error number="118" text="' . $newpath . '" />';
		return;
	}
	
	echo "<Adjusted name=\"{$newfile}\" url=\"{$newUrl}\" />";
}
?>